import java.util.LinkedList;
import java.util.List;

public class AlgoFF extends PasAPas {

    private Graphe graphe;
    private int etatDuThread =0;
    //--------------------------------
    // Etat du Thread
    // 0 Stopped
    // 1 Running
    //--------------------------------
    
    
    
    //---------------------------------------------------
    // Constructeur:
    // C dans le nom ...
    //---------------------------------------------------
    
    
    public AlgoFF(Graphe gra) {
	graphe=gra;
    }




    //----------------------------------------------------
    // Fonction markage():
    // Effectue le markage sur le graphe ... 
    //---------------------------------------------------- 
    
    private boolean marquage (Sommet source,Sommet puit) {
	
	// retourne true si il ny a pas de chemin
	// false dans le cas contraire
	
	
	//Initialisation des variables
	int i,tailleList;
	Sommet sommetCourant;
	Arc arcCourant;
	boolean fin=false;
	
	LinkedList ascanner= new LinkedList();
	LinkedList tmpList=new LinkedList();
	//plutot une file ou pile
    
	System.out.println("(---) Entree dans markage ...");
	
	
	//System.out.println("(---) Demarkage du graphe");
	graphe.nettoyage();
	
	pause();
	
	// On commence a la source ...
	ascanner.add(source);
	source.setDelta(-1);
	source.marquer();
	pause();
	
	//System.out.println("(---) Entree dans la boucle de markage");
    
	// On boucle tant ke lon a po rallier le puit ...
	while(!puit.estMarque() && !fin)
	    {
	
		//try
		//{
		pause();
		sommetCourant=(Sommet)ascanner.getFirst();
		//}
		//catch(IndexOutOfBoundsException e)
		//{
		//System.out.println("Gros problemo");
		//}
		
		//-------------------------------------
		//   Pas a Pas
		sommetCourant.setEtat(2);
		System.out.println("(III) |-- Scannage de "+sommetCourant.getId());
		pause();
		//-------------------------------------
		
		tmpList.clear();
		tmpList.addAll(sommetCourant.obtenirSortant());
		//System.out.println("(---) "+sommetCourant.getId()+" : Arcs Sortants");
		tailleList=tmpList.size();
		
		for(i=0;i<tailleList;i++)	  {
		    
		    arcCourant=(Arc)tmpList.get(i);
		    
		    if(arcCourant.getTerminal().estMarque()==false && arcCourant.getFlot()<arcCourant.getCapacite())
			{
			    
			    arcCourant.getTerminal().marquer();
			    arcCourant.getTerminal().fixerProvenance(arcCourant,false);
			    if(sommetCourant.getDelta()!=-1)
				{
				    arcCourant.getTerminal().setDelta(min(sommetCourant.getDelta(),(arcCourant.getCapacite()-arcCourant.getFlot())));
				}
			    else
				{
				    arcCourant.getTerminal().setDelta(arcCourant.getCapacite()-arcCourant.getFlot());
				}
			    ascanner.add(arcCourant.getTerminal());
			    //---------------------------------------
			    //  Pas a Pas
			    System.out.println("(III) |   |-- Marquage de "+arcCourant.getTerminal().getId()+" --- "+arcCourant.getTerminal().getDelta());
			    //---------------------------------------
			    
			}
		    
		    //--------------------------------
		    // Pas A Pas
		    arcCourant.setEtat(1);
		    pause();
		    arcCourant.setEtat(0);
		    //--------------------------------
		    
		    
		}
		
		tmpList.clear();
		tmpList.addAll(sommetCourant.obtenirEntrant());
		//System.out.println("(---) "+sommetCourant.getId()+" : Arcs Entrants");
		tailleList=tmpList.size();
		for(i=0;i<tailleList;i++)
		    {
			
			arcCourant=(Arc)tmpList.get(i);
			
			if(arcCourant.getInitial().estMarque()==false && arcCourant.getFlot()>0)
			    {
		
				arcCourant.getInitial().marquer();
				arcCourant.getInitial().fixerProvenance(arcCourant,true);
				if(sommetCourant.getDelta()!=-1)
				    {
					arcCourant.getInitial().setDelta(min(sommetCourant.getDelta(),arcCourant.getFlot()));
				    }
				else
				    {
					arcCourant.getInitial().setDelta(arcCourant.getFlot());
				    }
				ascanner.add(arcCourant.getInitial());
				
				//------------------
				// Pas a Pas
				System.out.println("(III) |   |-- Marquage de "+arcCourant.getInitial()+" --- "+arcCourant.getInitial().getDelta()+" (Neg)");
				//------------------
				
			    }
			
			//--------------------------------
			// Pas A Pas
			arcCourant.setEtat(1);
			pause();
			arcCourant.setEtat(0);
			//--------------------------------
			
			
		    }
		
		//------------------------------
		// Gestion des Etats pour le mode pas a pas
		//-----------------------------
		sommetCourant.setEtat(3);
		ascanner.remove(0);
		if(ascanner.size()==0)
		    {
			// Il n'y a plus de chemin possible donc on sort de la boucle ...
			System.out.println("(III) |-- Plus rien a scanner !!! Po de Chemin possible");
			fin=true;
		    }	
		
	    }
	if(puit.estMarque())
	    {
		System.out.println("(III) |-- Puit Marke !!! on a trouve un chemin");
	    }	
	System.out.println("(---) Sortie de markage ...");
	return fin;
    }	
    
    public int min(int a,int b) {
	if(a>b)
	    {
		return b;
	    }
	else
	    {
		return a;
	    }
    }
    
    //----------------------------------------------------
    // Fonction augmentationFlot():
    // Effectue l'augmentation du flot apres un markage successfull ... 
    //---------------------------------------------------- 
    
    private int augmentationFlot(Sommet source,Sommet puit) {
	
	// augmentation du flot dans le graphe de la valeur a 
	int augmentation = puit.getDelta();
	Sommet sommetCourant = puit;
	Sommet sommetSuivant;
	//Sommet source = this.obtenirSource();
	
	// Debuggage
	System.out.print("(III) Augmentation du flot : "+augmentation+" / ");
	
	
	while(sommetCourant!=source) {
	    //Sommet sommetSuivant = sommetCourant.obtenirS();
	    // Debuggage
	    System.out.print(sommetCourant.getId()+" - ");	  
	    // -------------------
	    //--------------------
	    // Pas a Pas 
	    sommetCourant.obtenirProvenance().setEtat(2);      
	    //----------------------
	    
	    if(sommetCourant.estUnDeltaNegatif()==false)
		{
		    sommetCourant.obtenirProvenance().augmenterFlot(augmentation);
		    sommetSuivant = sommetCourant.obtenirProvenance().getInitial();
		}
	    else
		{
		    sommetCourant.obtenirProvenance().diminuerFlot(augmentation);
		    sommetSuivant = sommetCourant.obtenirProvenance().getTerminal();  
		}
	    
	    sommetCourant = sommetSuivant;
	    
	}
	System.out.println(source.getId());
	return augmentation;
    }

    public void run () {

	etatDuThread=1;
	while(!this.marquage(graphe.getSource(),graphe.getPuit()))
	    {
		this.augmentationFlot(graphe.getSource(),graphe.getPuit());
		viewer.debloquerBoutons();
		attendreEtapeSuivante();
	    }
	viewer.debloquerBoutons();
	viewer.repaint();
	etatDuThread=2;
    }
    
    public int getEtatDuThread(){
	return etatDuThread;
    }



}
