//package code2001b;

import java.awt.*;
import javax.swing.*;
import java.lang.*;

/**
 * @author
 */

//-------------------------------------------------//
//                                                 //
//                CLASSE ARCAFF                    //
//                                                 //
//-------------------------------------------------//
 
public class ArcAFF {

  Color couleur;
  Arc monArc;
  Point pInit = new Point(0,0);
  Point pTerm = new Point(0,0);
  boolean useEditeur=false;

  //---------------------------------------------------
  // Constructeur:
  // C dans le nom ...
  //---------------------------------------------------

    public ArcAFF(Arc arc,boolean b) {
      monArc = arc;
      useEditeur = b;

    }
    public ArcAFF(Arc arc) {
      monArc = arc;
      useEditeur = false;

    }



    public Arc getArc() {
	return this.monArc;
    }

	public void setPInit(Point p) {
		this.pInit = p;
	}
	
	public void setPTerm(Point p) {
		this.pTerm = p;
	}
	
	public Point getPInit() {
		return this.pInit;
	}
	
	public Point getPTerm() {
		return this.pTerm;
	}
	
  //---------------------------------------------------
  // Fonction dessiner():
  // Permet de dessiner l'Arc
  //---------------------------------------------------

    public void dessiner(Graphics g, int pasX, int pasY) {	

	FontMetrics fm = g.getFontMetrics();

	// Couleur de remplissage du cercle
      setCouleur();
      g.setColor(couleur);

      // On recupere les coordonnees de chacun des sommets
      // en rajoutant le rayon du sommet
      int x1 = monArc.getInitial().getX()*pasX;
      int y1 = monArc.getInitial().getY()*pasY;
      int x2 = monArc.getTerminal().getX()*pasX;
      int y2 = monArc.getTerminal().getY()*pasY;
      
      // On caclcule le milieu de l'arc
      int milieuX = (x1+x2)/2;
      int milieuY = (y1+y2)/2;

      int dx = x2 - x1;
      int dy = y2 - y1;
      double coef = (SommetAFF.getRayon())/Math.sqrt(dx*dx + dy*dy);
      int xx1 = x1 + (int)(dx*coef);
      int yy1 = y1 + (int)(dy*coef);
      int xx2 = x2 - (int)(dx*coef);
      int yy2 = y2 - (int)(dy*coef);


      // On affiche l'arc
      g.drawLine(xx1,yy1,xx2,yy2);
      
      // Trace des fleches pour indiquer le sens des arcs
      //g.setColor(Color.green);
      int dxa = (int)((x2-xx2)/2);
      int dya = (int)((y2-yy2)/2);
      int xa = xx2 - dxa;
      int ya = yy2 - dya;
      int xa1 = xa +(int)(dya/2);
      int ya1 = ya - (int)(dxa/2);
      int xa2 = xa -(int)(dya/2);
      int ya2 = ya + (int)(dxa/2);

      int xpoints[] = {xx2, xa1, xa2};
      int ypoints[] = {yy2, ya1, ya2};
      g.fillPolygon(xpoints, ypoints, 3);

      // Couleur de la police
      String lbl;
      if(useEditeur){
	  lbl=Integer.toString(monArc.getFlot())+"/"+Integer.toString(monArc.getCapacite());
      }
      else{
	  lbl=Integer.toString(monArc.getCapacite());
      }
      int haut=fm.getHeight()+1;
      int larg=fm.stringWidth(lbl) + 10;

      g.setColor(Color.yellow);
      g.fillRect(milieuX - larg/2 , milieuY - haut/2 , larg ,haut);
      // Dessin de la police
      g.setColor(couleur);
      g.drawRect(milieuX - larg/2 , milieuY - haut/2 , larg  ,haut);
      g.drawString(lbl,milieuX-(larg-10)/2,(milieuY-(haut-1)/2) + fm.getAscent());
      
    }

  //---------------------------------------------------
  // Fonction setCouleur():
  // Permet de definir la couleur de l'ArcAFF en fonction de l'Etat
  //---------------------------------------------------

  public void setCouleur() {
      
      int etat=0;
      
      if(useEditeur){
	  etat=monArc.getEtat();
      }
      
      switch(etat)
	  {
	  case 0:
	      couleur=Color.black;
	      break;
	  case 1:
	      couleur=Color.blue;
	      break;
	  case 2:
	      couleur=Color.red;
	      break;
	  default:
	      couleur=Color.yellow;
	  }
  }


//--------------------------------------------------------------//
//                                                              //
//                   Fin de la CLASSE				//
//                                                              //
//--------------------------------------------------------------//
    
}
