//package code2001b;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

//import code2001b.Sommet;

/**
 * @author nom
 */

//-------------------------------------------------//
//                                                 //
//                CLASSE GRAPHE                    //
//                                                 //
//-------------------------------------------------//
 
public class Graphe{


    private LinkedList listeSommet;
    private LinkedList listeArc;
    private static int compteur; 
    
    private Sommet source;
    private Sommet puit;
    
    private int etatDuThread =0;
    //--------------------------------
    // Etat du Thread
    // 0 Stopped
    // 1 Running
    // 2 Finished
    //--------------------------------
    
    //---------------------------------------------------
    // Constructeur:
    // C dans le nom ...
    //---------------------------------------------------
    
    public Graphe() {
	listeSommet = new LinkedList();
	listeArc = new LinkedList();
	compteur = 0;
	source=null;
	puit=null;
    }
    
    
    //-----------------------------------------------------//
    //-----------------------------------------------------//
    //                       Methodes                      //
    //-----------------------------------------------------//
    //-----------------------------------------------------//
    
    
    /*
      public Sommet ajouterSommet() {
      Sommet s = new Sommet(++compteur);
      listeSommet.add(s);
      return s;
      }
    */ 
    
    //---------------------------------------------------
    // Fonction ajouterSommet():
    // Permet d'ajouter un sommet au graphe
    //---------------------------------------------------
    
    public Sommet ajouterSommet(int x, int y) {
	Sommet s = new Sommet(++compteur, x, y);
	listeSommet.add(s);
	return s;
    }
    public Sommet ajouterSommet(int x, int y, int id) {
	Sommet s = new Sommet(id, x, y);
	listeSommet.add(s);
	if(id>=compteur){
	  compteur=id+1;
	}
 	return s;
   }
    
    //---------------------------------------------------
    // Fonction enleverSommet():
    // Enlever le sommet
    //---------------------------------------------------
    
    public void enleverSommet(Sommet s) {
	listeSommet.remove(s);
    }

  //---------------------------------------------------
  // Fonction enleverArc() :
  // Enlever l'Arc
  //---------------------------------------------------
  
  public void enleverArc(Arc a) {
      a.getInitial().enleverArc(a);
      a.getTerminal().enleverArc(a);
      listeArc.remove(a);
  }
  
  //---------------------------------------------------
  // Fonction estConnexe():
  // Permettra de verifier si le Graphe est correct ...
  //---------------------------------------------------
    
    public boolean estConnexe() {
    
    int indexMax=listeSommet.size();
    int i=0;
    boolean connexe=true;
    Sommet sommetCourant;
    
    //System.out.println("Tutut");
    while((i<indexMax) && connexe)
      {
	  //System.out.println("VroumVroum");
	sommetCourant=(Sommet)listeSommet.get(i);
	if(sommetCourant==source)
	  {
	    if(sommetCourant.obtenirSortant().size()==0 || sommetCourant.obtenirEntrant().size()>0)
	      {
		connexe=false;
	      }
	  }
	else if(sommetCourant==puit)
	  {
	    if(sommetCourant.obtenirEntrant().size()==0 || sommetCourant.obtenirSortant().size()>0)
	      {
		connexe=false;
	      }
	  }
	else
	  {
	    if(sommetCourant.obtenirEntrant().size()==0 || sommetCourant.obtenirSortant().size()==0)
	      {
		connexe=false;
	      }
	  }
	i++;
      }

    return connexe;
 
    
  }


    //---------------------------------------------------
    // Fonction ajouterArc():
    // Permet d'ajouter un arc dans le Graphe
    //---------------------------------------------------
    
    public Arc ajouterArc(Sommet sInitial, Sommet sTerminal, int capacite) {
	Arc arc = new Arc (sInitial,sTerminal,capacite);
	listeArc.add(arc);
	return arc;
    }
    public Arc ajouterArc(Arc arc) {
	listeArc.add(arc);
	return arc;
    }
    
    //---------------------------------------------------
    // Fonction getListeSommet():
    // Recuperer la liste des Sommets du graphe
    //---------------------------------------------------
    
    public LinkedList getListeSommet() {
	return listeSommet;
    }
    
    //---------------------------------------------------
    // Fonction getSommetById():
    // Recupere un sommet du graphe a partir de son id
    //---------------------------------------------------
    
    public Sommet getSommet(int id) {
	int i=0,taille;
	boolean trouve=false;
	Sommet sommetCourant=null;
	
	taille=listeSommet.size();
	//System.out.println("Taille:"+taille);
	while((i<taille) && !trouve)
	    {
		sommetCourant=(Sommet)listeSommet.get(i);
		if(sommetCourant.getId()==id)
		    {
			trouve=true;
			
		    }
		i++;
	    }
	return sommetCourant;
    }
    
    //----------------------------------------------------
    // Fonction getMaxX():
    // Recupere le X maxx dans le graphe 
    //---------------------------------------------------- 
    
    public int getMaxX() {
	int taille,i,maxX=0;
	Sommet sommetCourant;
	
	taille=listeSommet.size();
	for(i=0;i<taille;i++)
	    {
		sommetCourant=(Sommet)listeSommet.get(i);
		if(sommetCourant.getX()>maxX)
		    {
			maxX=sommetCourant.getX();
		    }
	    }
	return maxX;
    }
    
    //----------------------------------------------------
    // Fonction getMaxY():
    // Recupere le Y maxx dans le graphe 
    //---------------------------------------------------- 
    
    public int getMaxY() {
	int taille,i,maxY=0;
	Sommet sommetCourant;
    
	taille=listeSommet.size();
	for(i=0;i<taille;i++)
	    {
		sommetCourant=(Sommet)listeSommet.get(i);
		if(sommetCourant.getY()>maxY)
		    {
			maxY=sommetCourant.getY();
		    }
	    }
	return maxY;
    }
    //----------------------------------------------------
    // Fonction getMinX():
    // Recupere le X minn dans le graphe 
    //---------------------------------------------------- 
    
    public int getMinX() {
	int taille,i,minX=source.getX();;
	Sommet sommetCourant;
	
	taille=listeSommet.size();
	for(i=0;i<taille;i++)
	    {
		sommetCourant=(Sommet)listeSommet.get(i);
		if(sommetCourant.getX()<minX)
		    {
			minX=sommetCourant.getX();
		    }
	    }
	return minX;
    }
    
  //----------------------------------------------------
  // Fonction getMaxY():
  // Recupere le Y maxx dans le graphe 
  //---------------------------------------------------- 
    
    public int getMinY() {
	int taille,i,minY=source.getY();;
	Sommet sommetCourant;
	
	taille=listeSommet.size();
	for(i=0;i<taille;i++)
	    {
		sommetCourant=(Sommet)listeSommet.get(i);
		if(sommetCourant.getY()<minY)
		    {
			minY=sommetCourant.getY();
		    }
	    }
	return minY;
    }
    
    //----------------------------------------------------
    // Fonction getListeArc():
    // Recuperer la liste des Arcs du graphe 
    //---------------------------------------------------- 
    
    public LinkedList getListeArc() {
	return listeArc;
    }
    
    //----------------------------------------------------
    // Fonction printConsole():
    // Affichage du Graphe dans la console ...
    // principale utilite le debuggage 
    //---------------------------------------------------- 
    
  public void printConsole() {
      
      int i,taille;
      Sommet sommetCourant;
      Arc arcCourant;
      taille=listeSommet.size();
      for(i=0;i<taille;i++)
	  {
	      sommetCourant=(Sommet)listeSommet.get(i);
	      System.out.println("Sommet Id:"+sommetCourant.getId()+" @ "+sommetCourant.getX()+","+sommetCourant.getY());
	  }
      taille=listeArc.size();
      for(i=0;i<taille;i++)
	  {
	      arcCourant=(Arc)listeArc.get(i);
	      System.out.println("Arc I: "+arcCourant.getInitial().getId()+" T: "+arcCourant.getTerminal().getId()+" Capa: "+arcCourant.getCapacite());
	  }
      
  }
    

    //public void enleverArc(Sommet sInitial, Sommet sTerminal) {
    //}
    
    //----------------------------------------------------
    // Fonction getListeArc():
    // Recuperer la liste des sommets du graphe 
    //---------------------------------------------------- 
    
    public void enregistrer(/*String nomFichier*/) {//throws IOException {
	
	this.printConsole();
	//FileWriter f = new FileWriter(nomFichier);
    }
    
    public void ouvrirGraphe(String nomFichier) {
    }
  
    public void deleteGraphe() throws Throwable {
	this.finalize();
    }
    
    //----------------------------------------------------
    // Fonction demarquerTout():
    // Demarker tout le Graphe ... 
    //---------------------------------------------------- 
    
    public void nettoyage() {
	
	int i=0;
	int indexMax=listeSommet.size();
	int indexMax_2=listeArc.size();
	Sommet sommetCourant;
	Arc arcCourant;
	
	
	for(i=0;i<indexMax;i++)
	    {
		
		sommetCourant=(Sommet)listeSommet.get(i);
		sommetCourant.demarquer();
		
	    }
	for(i=0;i<indexMax_2;i++)
	    {
		
		arcCourant=(Arc)listeArc.get(i);
		arcCourant.setEtat(0);
		
	    }
	
    }

    //----------------------------------------------------
    // Fonction faireRAZ():
    // Remet le graphe a zero 
    //---------------------------------------------------- 
   
    public void faireRAZ() {
	
	int i=0;
	int indexMax=listeSommet.size();
	int indexMax_2=listeArc.size();
	Sommet sommetCourant;
	Arc arcCourant;
	
	for(i=0;i<indexMax;i++)
	    {
		sommetCourant=(Sommet)listeSommet.get(i);
		sommetCourant.setDelta(-1);
		sommetCourant.setEtat(0);
	    }
	for(i=0;i<indexMax_2;i++)
	    {
		arcCourant=(Arc)listeArc.get(i);
		arcCourant.setFlot(0);
		arcCourant.setEtat(0);
	    }
    
    }

    //----------------------------------------------------
    // Fonction setSource(), getSource(), setPuit(), getPuit():
    // Fonctions de gestion de la source et du puit
    //---------------------------------------------------- 

    public void setSource(Sommet s) {
	source=s;
    }
    
    public void setPuit(Sommet s) {
	puit=s;
    }
    
    public Sommet getSource() {
	return source;
    }
    
    public Sommet getPuit() {
	return puit;
    }

    //----------------------------------------------------
    // Fonction getFlotfaireRAZ():
    // Calcul du flot du graphe 
    //---------------------------------------------------- 
    
    public int getFlot(){
	int taille=0,resultat=0,i;
	LinkedList tmplist = new LinkedList();
	Arc arcCourant= null;
	
	tmplist.addAll(source.obtenirSortant());
	taille=tmplist.size();
	for(i=0;i<taille;i++)
	    {
		arcCourant=(Arc)tmplist.get(i);
		resultat+=arcCourant.getFlot();
	    }
    return resultat;
    }

    public void clear(){

	listeSommet.clear();
	listeArc.clear();
	source=null;
	puit=null;
	compteur=0;

    }  

  public void recaler(){
    int minX=getMinX();
    int minY=getMinY();
    int taille=listeSommet.size();
    int i;
    Sommet sommetCourant;

    for(i=0;i<taille;i++){
      sommetCourant=(Sommet)listeSommet.get(i);
      sommetCourant.setX(sommetCourant.getX()-minX+1);
      sommetCourant.setY(sommetCourant.getY()-minY+1);
    }
  }
//--------------------------------------------------------------//
//                                                              //
//                   Fin de la CLASSE				//
//                                                              //
//--------------------------------------------------------------//
}
	
